# OpalNullMediaStream Class Reference

`#include <mediastrm.h>`

Inheritance diagram for OpalNullMediaStream:

[legend]
Collaboration diagram for OpalNullMediaStream:
[legend]

## Public Member Functions

Construction
| OpalNullMediaStream (OpalConnection &conn, const OpalMediaFormat &mediaFormat, unsigned sessionID, bool isSource, bool isSynchronous=false)
| OpalNullMediaStream (OpalConnection &conn, const OpalMediaFormat &mediaFormat, unsigned sessionID, bool isSource, bool usePacingDelay, bool requiresPatchThread)
Overrides of OpalMediaStream class
virtual PBoolean | ReadData (BYTE *data, PINDEX size, PINDEX &length)
virtual PBoolean | WriteData (const BYTE *data, PINDEX length, PINDEX &written)
virtual bool | SetPaused (bool pause, bool fromPatch=false)
virtual PBoolean | RequiresPatchThread () const
virtual PBoolean | IsSynchronous () const

## Protected Member Functions

virtual void | InternalClose ()
virtual bool | InternalUpdateMediaFormat (const OpalMediaFormat &newMediaFormat)

## Protected Attributes

bool | m_isSynchronous
bool | m_requiresPatchThread

## Detailed Description

This class describes a media stream that is used for media bypass.

## Constructor & Destructor Documentation

OpalNullMediaStream::OpalNullMediaStream | ( | OpalConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | bool | isSource,
|  | bool | isSynchronous = `false` |
| ) |  |  |

Construct a new media stream for RTP sessions.

Parameters:

  conn | Connection that owns the stream
  mediaFormat | Media format for stream
  sessionID | Session number for stream
  isSource | Is a source stream
  isSynchronous | Can accept data and block accordingly

OpalNullMediaStream::OpalNullMediaStream | ( | OpalConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | bool | isSource,
|  | bool | usePacingDelay,
|  | bool | requiresPatchThread |
| ) |  |  |

Parameters:

  conn | Connection that owns the stream
  mediaFormat | Media format for stream
  sessionID | Session number for stream
  isSource | Is a source stream
  usePacingDelay | Use delay to pace stream I/O
  requiresPatchThread | Requires a patch thread to execute

## Member Function Documentation

virtual void OpalNullMediaStream::InternalClose | ( |  | ) | `[inline, protected, virtual]`

Close any internal components of the stream. This should be used in preference to overriding the Close() function as it is guaranteed to be called exactly once and avoids race conditions in the shut down sequence of a media stream.

Implements OpalMediaStream.

virtual bool OpalNullMediaStream::InternalUpdateMediaFormat | ( | const OpalMediaFormat & | newMediaFormat | ) | `[protected, virtual]`

Reimplemented from OpalMediaStream.

virtual PBoolean OpalNullMediaStream::IsSynchronous | ( |  | ) | const`[virtual]`

Indicate if the media stream is synchronous. Returns m_isSynchronous.

Implements OpalMediaStream.

virtual PBoolean OpalNullMediaStream::ReadData | ( | BYTE * | data,
|  | PINDEX | size,
|  | PINDEX & | length |
| ) |  |  | `[virtual]`

Read raw media data from the source media stream. The default behaviour does nothing and returns false.

Parameters:

  data | Data buffer to read to
  size | Size of buffer
  length | Length of data actually read

Reimplemented from OpalMediaStream.

virtual PBoolean OpalNullMediaStream::RequiresPatchThread | ( |  | ) | const`[virtual]`

Indicate if the media stream requires a OpalMediaPatch thread (active patch). The default behaviour returns the value of m_isSynchronous.

Reimplemented from OpalMediaStream.

virtual bool OpalNullMediaStream::SetPaused | ( | bool | pause,
|  | bool | fromPatch = `false` |
| ) |  |  | `[virtual]`

Set the paused state for stream. This will stop reading/writing data from the stream. Returns true if the pause state was changed

Parameters:

  pause | Indicate that the stream should be paused
  fromPatch | Is being called from OpalMediaPatch

Reimplemented from OpalMediaStream.

virtual PBoolean OpalNullMediaStream::WriteData | ( | const BYTE * | data,
|  | PINDEX | length,
|  | PINDEX & | written |
| ) |  |  | `[virtual]`

Write raw media data to the sink media stream. The default behaviour does nothing and returns false.

Parameters:

  data | Data to write
  length | Length of data to read.
  written | Length of data actually written

Reimplemented from OpalMediaStream.

## Field Documentation

bool OpalNullMediaStream::m_isSynchronous `[protected]`

bool OpalNullMediaStream::m_requiresPatchThread `[protected]`

The documentation for this class was generated from the following file:

- mediastrm.h